function Create(self)
	self.Frame = 0
	self.FrameTarget = 0
	self.GliderDamage = 0
end

function Update(self)
  if self.Sharpness > 1 then
    self.GliderDamage = self.GliderDamage + self.Sharpness - 1
    self.Sharpness = 1
  end
  if not self:IsAttached() and ActivityMan:GetActivity().ActivityState ~= Activity.EDITING then
    local strikePoint = self.Pos + self:RotateOffset(Vector(0 , 45));
    Strength = SceneMan:CastStrengthRay(self.Pos, self:RotateOffset(Vector(0 , 45)) , 10, strikePoint, 0 , 0 , SceneMan.SceneWrapsX);
    local pos = SceneMan:GetLastRayHitPos()
    local strikePoint = self.Pos + self:RotateOffset(Vector(0 , -45));
    Strength = SceneMan:CastStrengthRay(self.Pos, self:RotateOffset(Vector(0 , -45)) , 10, strikePoint, 0 , 0 , SceneMan.SceneWrapsX);
    local pos2 = SceneMan:GetLastRayHitPos()
    self.FrameTarget = math.max(0 , math.min(SceneMan:ShortestDistance(self.Pos,pos,SceneMan.SceneWrapsX).Magnitude/5 - 1 , SceneMan:ShortestDistance(self.Pos,pos2,SceneMan.SceneWrapsX).Magnitude/5 - 1))
    if math.min(8 ,self.FrameTarget) == 8 then
      self.FrameTarget = 12
    end
    local direction = self.Vel.AbsRadAngle
    
    local AirRessistanceForce = 0.003 * self.AngularVel^2 * self.Frame/self.Mass*(60 - self.GliderDamage)/60
    if self.AngularVel > 0 then
      if self.AngularVel - AirRessistanceForce > 0 then
        self.AngularVel = self.AngularVel - AirRessistanceForce
      else
        self.AngularVel = 0
      end
    else
      if self.AngularVel + AirRessistanceForce < 0 then
        self.AngularVel = self.AngularVel + AirRessistanceForce
      else
        self.AngularVel = 0
      end
    end
    local RotAngleVector = Vector(math.cos(self.RotAngle * -1 + math.pi*0.5) , math.sin(self.RotAngle * -1 + math.pi*0.5))
    local AirShadow = (RotAngleVector * (self.Vel.Normalized.X*RotAngleVector.X + self.Vel.Normalized.Y*RotAngleVector.Y)).Magnitude
    local RotAngleVectorPer = RotAngleVector.Perpendicular
    local DirectionalSpeed = (RotAngleVectorPer * (self.Vel.X*RotAngleVectorPer.X + self.Vel.Y*RotAngleVectorPer.Y)).Magnitude
    local negatore = 1
    if (self.Vel.Normalized.X*RotAngleVector.Y - self.Vel.Normalized.Y*RotAngleVector.X) < 0 then
      negatore = -1;
    end

    local DirectionalSpeedX = (RotAngleVector * (self.Vel.X*RotAngleVector.X + self.Vel.Y*RotAngleVector.Y)).Magnitude

    local modifier = (self.GliderDamage - self.GliderDamage*0.5)/50
    local power = 0.03*self.Vel.Magnitude^2*(60 - self.GliderDamage)/60
    local i = math.floor(power)
    local i = math.floor(power)
    while i > 0 do
      self.AngularVel = self.AngularVel - math.sin((self.RotAngle + self.AngularVel*0.2 + math.pi*0.5 + modifier - direction)*2) * self.Frame/self.Mass
      i = i - 1
    end
    self.AngularVel = self.AngularVel - math.sin((self.RotAngle + self.AngularVel*0.2 + math.pi*0.5 + modifier - direction)*2)*(power-math.floor(power)) * self.Frame/self.Mass
        
    local AirRessistanceForce = AirShadow * -10 * DirectionalSpeed^2 * self.Frame
  --      self.Vel = self.Vel - RotAngleVectorPer*AirRessistanceForce * negatore
    self:AddAbsForce( RotAngleVectorPer*AirRessistanceForce * negatore*(60 - self.GliderDamage)/60,self.Pos );
    if self.Frame <= self.FrameTarget-1 then
      self.Frame = self.Frame + 1
      if self.Frame < 9 then
        if self.HFlipped then
          self.AngularVel = self.AngularVel + 45/self.Mass
        else
          self.AngularVel = self.AngularVel - 45/self.Mass
        end
        self.AngularVel = self.AngularVel * 0.925^(50/self.Mass)
        self:AddAbsForce( self:RotateOffset(Vector(0 , -4500)),self.Pos );
      end
    elseif self.Frame >= self.FrameTarget+1 then
      self.Frame = self.Frame - 1
      if self.Frame < 9 then
        if self.HFlipped then
          self.AngularVel = self.AngularVel - 45/self.Mass
        else
          self.AngularVel = self.AngularVel + 45/self.Mass
        end
        self.AngularVel = self.AngularVel * 1.075^(50/self.Mass)
        self:AddAbsForce( self:RotateOffset(Vector(0 , 4500)),self.Pos );
      end
    end
    self.Frame = math.floor(self.Frame)
    if self.Frame == 13 and AirRessistanceForce ~= nil and (self.Frame == 9 or self.Frame == 11 or self.Frame == 12 or self.Frame == 13) then
      local frameforce = math.abs(DirectionalSpeedX) - math.abs(AirRessistanceForce*0.05)
      if frameforce < -40 then
        self.Frame = 13
      elseif  frameforce < -20 then
        self.Frame = 11
      elseif  frameforce < 20 then
        self.Frame = 12
      else
        self.Frame = 9
      end
    end
  end
end

function Destroy(self)
  local gib = CreateMOSRotating("GliderGib1");
  gib.Pos = self.Pos + self:RotateOffset(Vector(-2 , 7))
  gib.Vel = self.Vel + Vector(math.random()*4-2 , math.random()*4-2)
  gib.RotAngle = self.RotAngle
  gib.AngularVel = self.AngularVel
  gib.HFlipped = self.HFlipped
  MovableMan:AddParticle(gib);
  
  local gib = CreateMOSRotating("GliderGib2");
  gib.Pos = self.Pos + self:RotateOffset(Vector(2 , 6))
  gib.Vel = self.Vel + Vector(math.random()*4-2 , math.random()*4-2)
  gib.RotAngle = self.RotAngle
  gib.AngularVel = self.AngularVel
  gib.HFlipped = self.HFlipped
  MovableMan:AddParticle(gib);
  
  local gib = CreateMOSRotating("GliderGib3");
  gib.Pos = self.Pos + self:RotateOffset(Vector(2 , -2))
  gib.Vel = self.Vel + Vector(math.random()*4-2 , math.random()*4-2)
  gib.RotAngle = self.RotAngle
  gib.AngularVel = self.AngularVel
  gib.HFlipped = self.HFlipped
  MovableMan:AddParticle(gib);
  
  local gib = CreateMOSRotating("GliderGib4");
  gib.Pos = self.Pos + self:RotateOffset(Vector(-3 , -7))
  gib.Vel = self.Vel + Vector(math.random()*4-2 , math.random()*4-2)
  gib.RotAngle = self.RotAngle
  gib.AngularVel = self.AngularVel
  gib.HFlipped = self.HFlipped
  MovableMan:AddParticle(gib);
end